{--------------------------------------------------------}
{
{    Controle da Fala
{
{    Autor: Marcelo Luis Pinheiro
{
{    Orientador Academico: Jose' Antonio Borges
{
{    Em 10/12/93
{
{--------------------------------------------------------}

Unit edMensag;

interface
uses
    DVcrt, DVWin,
    edvars;

function textoAjuda (f: string): string;
Procedure Fala (f: String);
Procedure FalaSeguinte (f: String);
function leTeclaMaiusc: char;
function txtmsg (f: string): string;

{--------------------------------------------------------}

implementation

function textoAjuda (f: string): string;
begin
    if f = 'EDAJIN1' then textoAjuda := 'Sao os seguintes:'
    else
    if f = 'EDAJIN2' then textoAjuda := '  C - comandos de cursor'
    else
    if f = 'EDAJIN3' then textoAjuda := '  L - linha'
    else
    if f = 'EDAJIN4' then textoAjuda := '  P - procura de textos'
    else
    if f = 'EDAJIN5' then textoAjuda := '  M - margem'
    else
    if f = 'EDAJIN6' then textoAjuda := '  A - arquivos'
    else
    if f = 'EDAJIN7' then textoAjuda := '  B - blocos de linhas'
    else
    if f = 'EDAJIN8' then textoAjuda := '  F - acionamento da fala'
    else
    if f = 'EDAJIN9' then textoAjuda := '  I - instalacao'
    else
    if f = 'EDAJIN10' then textoAjuda := '  E - letras especiais'
    else
    if f = 'EDAJIN11' then textoAjuda := '  W - tratamento Word'
    else

    if f = 'EDAJFW1' then textoAjuda := 'Os comandos de tratamento Word so'
    else
    if f = 'EDAJFW2' then textoAjuda := '  F - insere marcas de formatao'
    else
    if f = 'EDAJFW3' then textoAjuda := '  I - informa formatao no cursor'
    else
    if f = 'EDAJFW4' then textoAjuda := '  G - gera arquivo DOC'
    else
    if f = 'EDAJFW5' then textoAjuda := '  O - Ocultar formatao na tela'
    else
    if f = 'EDAJFW6' then textoAjuda := '  M - modos de falar formatao'
    else

    if f = 'EDAJLI1' then textoAjuda := 'Os comandos de linha sao:'
    else
    if f = 'EDAJLI2' then textoAjuda := '  I - insere uma linha acima'
    else
    if f = 'EDAJLI3' then textoAjuda := '  A - insere uma linha abaixo'
    else
    if f = 'EDAJLI4' then textoAjuda := '  R - remove linha'
    else
    if f = 'EDAJLI5' then textoAjuda := '  V - volta linha removida'
    else
    if f = 'EDAJLI6' then textoAjuda := '  Q - quebra linha em duas'
    else
    if f = 'EDAJLI7' then textoAjuda := '  J - junta duas linhas'
    else
    if f = 'EDAJLI8' then textoAjuda := '  E - exclui linhas com o texto'
    else
    if f = 'EDAJLI9' then textoAjuda := '  S - insere no incio da linha'
    else
    if f = 'EDAJLI10' then textoAjuda := '  D - insere no fim da linha'

    else

    if f = 'EDAJCU1' then textoAjuda := 'Os comandos de cursor sao:'
    else
    if f = 'EDAJCU2' then textoAjuda := '  - - inicio do texto'
    else
    if f = 'EDAJCU3' then textoAjuda := '  + - fim do texto'
    else
    if f = 'EDAJCU4' then textoAjuda := '  A - avana paragrafo'
    else
    if f = 'EDAJCU5' then textoAjuda := '  R - recua paragrafo'
    else
    if f = 'EDAJCU6' then textoAjuda := '  P - posiciona em certa linha'
    else
    if f = 'EDAJCU7' then textoAjuda := '  I - apaga inicio da linha'
    else
    if f = 'EDAJCU8' then textoAjuda := '  F - apaga fim da linha'
    else
    if f = 'EDAJCU9' then textoAjuda := '  L - informa linha'
    else
    if f = 'EDAJCU10' then textoAjuda := '  C - informa coluna'
    else
    if f = 'EDAJCU11' then textoAjuda := '  M - memoriza posicao do cursor'
    else
    if f = 'EDAJCU12' then textoAjuda := '  V - volta cursor `a posicao memorizada'
    else
    if f = 'EDAJCU13' then textoAjuda := '  N - avana para linha em branco'
    else
    if f = 'EDAJCU14' then textoAjuda := '  E - recua para linha em branco'
    else

    if f = 'EDAJBL1' then textoAjuda := 'Os comandos de bloco sao:'
    else
    if f = 'EDAJBL2' then textoAjuda := '  I - inicio do bloco'
    else
    if f = 'EDAJBL3' then textoAjuda := '  F - fim do bloco'
    else
    if f = 'EDAJBL4' then textoAjuda := '  M - move o bloco'
    else
    if f = 'EDAJBL5' then textoAjuda := '  C - copia o bloco'
    else
    if f = 'EDAJBL6' then textoAjuda := '  A - adiciona bloco a um arquivo'
    else
    if f = 'EDAJBL7' then textoAjuda := '  O - ordena o bloco'
    else
    if f = 'EDAJBL8' then textoAjuda := '  R - remove o bloco'
    else
    if f = 'EDAJBL9' then textoAjuda := '  D - desmarca o bloco'
    else
    if f = 'EDAJBL10' then textoAjuda := '  L - le arquivo gerando bloco'
    else
    if f = 'EDAJBL11' then textoAjuda := '  G - grava o bloco em arquivo'
    else
    if f = 'EDAJBL12' then textoAjuda := '  E - embeleza o bloco'
    else
    if f = 'EDAJBL13' then textoAjuda := '  P - paragrafo vira bloco'
    else
    if f = 'EDAJBL14' then textoAjuda := '  J - justifica paragrafo do cursor'
    else
    if f = 'EDAJBL15' then textoAjuda := '  S - envia para servidor de fala'
    else
    if f = 'EDAJBL16' then textoAjuda := '  V - verificao ortogrfica'
    else
    if f = 'EDAJBL17' then textoAjuda := '  X - decodificao'
    else
    if f = 'EDAJBL18' then textoAjuda := '  U - converter bloco'
    else
    if f = 'EDAJBL19' then textoAjuda := '  B - remover linhas em branco'
    else
    if f = 'EDAJBL20' then textoAjuda := '  W - transferncia no formato do Word'
    else
    if f = 'EDAJBL21' then textoAjuda := '  T - seleciona Todo o texto'
    else
    if f = 'EDAJBL22' then textoAjuda := '  Ctrl + B - remover linhas em branco deixando uma'
    else

    if f = 'EDAJMA1' then textoAjuda := 'Os comandos de margem sao:'
    else
    if f = 'EDAJMA2' then textoAjuda := '  M - informa margens'
    else
    if f = 'EDAJMA3' then textoAjuda := '  T - nova coluna de tabulacao'
    else
    if f = 'EDAJMA4' then textoAjuda := '  R - remove todas tabulacoes'
    else

    if f = 'EDAJAR1' then textoAjuda := 'Os comandos de arquivos sao:'
    else
    if f = 'EDAJAR2' then textoAjuda := '  I - informa nome do arquivo'
    else
    if f = 'EDAJAR3' then textoAjuda := '  S - salva arquivo e continua'
    else
    if f = 'EDAJAR4' then textoAjuda := '  N - edita um novo arquivo'
    else
    if f = 'EDAJAR5' then textoAjuda := '  C - salva como outro arquivo'
    else
    if f = 'EDAJAR6' then textoAjuda := '  F - salva e fim'
    else
    if f = 'EDAJAR7' then textoAjuda := '  A - abandona sem gravar'
    else
    if f = 'EDAJAR8' then textoAjuda := '  X - exporta formato IBM'
    else

    if f = 'EDAJBU1' then textoAjuda := 'Os comandos de busca sao:'
    else
    if f = 'EDAJBU2' then textoAjuda := '  P - procura texto'
    else
    if f = 'EDAJBU3' then textoAjuda := '  N - busca de novo'
    else
    if f = 'EDAJBU4' then textoAjuda := '  T - troca palavras por outras'
    else

    if f = 'EDAJFA1' then textoAjuda := 'Os comandos de fala sao:'
    else
    if f = 'EDAJFA2' then textoAjuda := '  I - fala inicio da linha'
    else
    if f = 'EDAJFA3' then textoAjuda := '  L - fala resto da linha'
    else
    if f = 'EDAJFA4' then textoAjuda := '  T - fala resto do texto'
    else

    if f = 'EDAJCF1' then textoAjuda := 'Os comandos de configuracao sao:'
    else
    if f = 'EDAJCF2' then textoAjuda := '  F - fala'
    else
    if f = 'EDAJCF3' then textoAjuda := '  I - insercao com Enter'
    else
    if f = 'EDAJCF4' then textoAjuda := '  A - acentuacao'
    else
    if f = 'EDAJCF5' then textoAjuda := '  S - soletragem'
    else
    if f = 'EDAJCF6' then textoAjuda := '  Q - quebra de linha automatica'
    else
    if f = 'EDAJCF7' then textoAjuda := '  V - velocidade'
    else

    if f = 'EDAJEM1' then textoAjuda := 'Os comandos de embelezamento sao:'
    else
    if f = 'EDAJEM2' then textoAjuda := '  C - centra bloco'
    else
    if f = 'EDAJEM3' then textoAjuda := '  M - acerta margens'
    else
    if f = 'EDAJEM4' then textoAjuda := '  A - alinha com as margens'
    else
    if f = 'EDAJEM5' then textoAjuda := '  T - tabula pela esquerda o bloco'
    else
    if f = 'EDAJEM6' then textoAjuda := '  I - indenta o bloco'
    else

    if f = 'EDAJCV1' then textoAjuda := 'As 50 converses so:'
    else
    if f = 'EDAJCV2' then textoAjuda := '  a minsculo - alqueire do norte para metros quadrados'
    else
    if f = 'EDAJCV3' then textoAjuda := '  A maisculo - alqueire mineiro para metros quadrados'
    else
    if f = 'EDAJCV4' then textoAjuda := '  b minsculo - alqueire paulista para metros quadrados'
    else
    if f = 'EDAJCV5' then textoAjuda := '  B maisculo - centmetros para ps'
    else
    if f = 'EDAJCV6' then textoAjuda := '  c minsculo - centmetros para  polegadas'
    else
    if f = 'EDAJCV7' then textoAjuda := '  C maisculo - centmetros quadrados para ps quadrados'
    else
    if f = 'EDAJCV8' then textoAjuda := '  d minsculo - gales para centmetros cbicos'
    else
    if f = 'EDAJCV9' then textoAjuda := '  D maisculo - gales para litros'
    else
    if f = 'EDAJCV10' then textoAjuda := '  e minsculo - gramas para libras'
    else
    if f = 'EDAJCV11' then textoAjuda := '  E maisculo - gramas para onas'
    else
    if f = 'EDAJCV12' then textoAjuda := '  f minsculo - hectare para metros quadrados'
    else
    if f = 'EDAJCV13' then textoAjuda := '  F maisculo - jardas para centmetros'
    else
    if f = 'EDAJCV14' then textoAjuda := '  g minsculo - jardas para metros'
    else
    if f = 'EDAJCV15' then textoAjuda := '  G maisculo - jardas quadradas para metros quadrados'
    else
    if f = 'EDAJCV16' then textoAjuda := '  h minsculo - libras para gramas'
    else
    if f = 'EDAJCV17' then textoAjuda := '  H maisculo - libras para quilogramas'
    else
    if f = 'EDAJCV18' then textoAjuda := '  i minsculo - litros para quartos'
    else
    if f = 'EDAJCV19' then textoAjuda := '  I maisculo - metros para jardas'
    else
    if f = 'EDAJCV20' then textoAjuda := '  j minsculo - metros para ps'
    else
    if f = 'EDAJCV21' then textoAjuda := '  J maisculo - metros para polegadas'
    else
    if f = 'EDAJCV22' then textoAjuda := '  k minsculo - metros quadrados para jardas quadradas'
    else
    if f = 'EDAJCV23' then textoAjuda := '  K maisculo - metros quadrados para ps quadrados'
    else
    if f = 'EDAJCV24' then textoAjuda := '  l minsculo - metros por minuto para centmetros por segundo'
    else
    if f = 'EDAJCV25' then textoAjuda := '  L maisculo - metros por minuto para ps por segundo'
    else
    if f = 'EDAJCV26' then textoAjuda := '  m minsculo - milhas para quilmetros'
    else
    if f = 'EDAJCV27' then textoAjuda := '  M maisculo - milhas para ns'
    else
    if f = 'EDAJCV28' then textoAjuda := '  n minsculo - milhas quadradas para quilmetros quadrados'
    else
    if f = 'EDAJCV29' then textoAjuda := '  N maisculo - milhas por hora para metros por segundo'
    else
    if f = 'EDAJCV30' then textoAjuda := '  o minsculo - milhas por hora para quilmetros por hora'
    else
    if f = 'EDAJCV31' then textoAjuda := '  O maisculo - ns para quilmetros por hora'
    else
    if f = 'EDAJCV32' then textoAjuda := '  p minsculo - onas para gramas'
    else
    if f = 'EDAJCV33' then textoAjuda := '  P maisculo - onas para quilogramas'
    else
    if f = 'EDAJCV34' then textoAjuda := '  q minsculo - ps para centmetros'
    else
    if f = 'EDAJCV35' then textoAjuda := '  Q maisculo - ps por minuto para centmetros por segundo'
    else
    if f = 'EDAJCV36' then textoAjuda := '  r minsculo - polegadas para centmetros'
    else
    if f = 'EDAJCV37' then textoAjuda := '  R maisculo - polegadas para ps'
    else
    if f = 'EDAJCV38' then textoAjuda := '  s minsculo - quartos para litros'
    else
    if f = 'EDAJCV39' then textoAjuda := '  S maisculo - quilogramas para libras'
    else
    if f = 'EDAJCV40' then textoAjuda := '  t minsculo - quilmetros para milhas'
    else
    if f = 'EDAJCV41' then textoAjuda := '  T maisculo - quilmetros para ps'
    else
    if f = 'EDAJCV42' then textoAjuda := '  u minsculo - quilmetros quadrados para jardas quadradas'
    else
    if f = 'EDAJCV43' then textoAjuda := '  U maisculo - quilmetros quadrados para milhas quadradas'
    else
    if f = 'EDAJCV44' then textoAjuda := '  v minsculo - quilmetros por hora para milhas por hora'
    else
    if f = 'EDAJCV45' then textoAjuda := '  V maisculo - quilmetros por hora para ps por minuto'
    else
    if f = 'EDAJCV46' then textoAjuda := '  w minsculo - Fahrenheit para Celsius'
    else
    if f = 'EDAJCV47' then textoAjuda := '  W maisculo - Celsius para Fahrenheit'
    else
    if f = 'EDAJCV48' then textoAjuda := '  x minsculo - Potenciao'
    else
    if f = 'EDAJCV49' then textoAjuda := '  X maisculo - Comprimento da circunferncia'
    else
    if f = 'EDAJCV50' then textoAjuda := '  y minsculo - rea do crculo'
    else
    if f = 'EDAJCV51' then textoAjuda := '  Y maisculo - Volume da esfera'
    else
    if f = 'EDAJCV52' then textoAjuda := '  z minsculo - Logartmo em qualquer base'
    else
    if f = ' EDAJCV53' then textoAjuda := '   minsculo agudo - Seno'
    else
    if f = 'EDAJCV54' then textoAjuda := '   maisculo agudo - Cosseno'
    else
    if f = 'EDAJCV55' then textoAjuda := '   minsculo agudo - Tangente'
    else
    if f = 'EDAJCV56' then textoAjuda := '   maisculo agudo - Cotangente'
    else
    if f = 'EDAJCV57' then textoAjuda := '   minsculo agudo - Secante'
    else
    if f = 'EDAJCV58' then textoAjuda := '   maisculo agudo - Cossecante'
    else
    if f = 'EDAJCV59' then textoAjuda := '   minsculo agudo - Logartmo Neperiano'
    else
    if f = 'EDAJCV60' then textoAjuda := '   maisculo agudo - Logartmo na base 10'
    else
    if f = 'EDAJCV61' then textoAjuda := '   minsculo agudo - Logartmo na base 2'
    else
    if f = 'EDAJCV62' then textoAjuda := '  Use as setas para selecionar.'
    else

    if f = 'EDAJDA1' then textoAjuda := '  J - justificar'
    else
    if f ='EDAJDA2' then textoAjuda := '  C - centralizar'
    else
    if f ='EDAJDA3' then textoAjuda := '  D - alinhar a direita'
    else
    if f ='EDAJDA4' then textoAjuda := '  E - alinhar a esquerda'
    else

    if f ='EDAJF01' then textoAjuda := '  F - nome da fonte'
    else
    if f ='EDAJF02' then textoAjuda := '  T - tamanho da fonte'
    else
    if f ='EDAJF03' then textoAjuda := '  C - cor da fonte'
    else
    if f ='EDAJF04' then textoAjuda := '  N - incio de negrito'
    else
    if f ='EDAJF05' then textoAjuda := '  CONTROL + N - fim de negrito'
    else
    if f ='EDAJF06' then textoAjuda := '  I - incio de itlico'
    else
    if f ='EDAJF07' then textoAjuda := '  CONTROL + I - fim de itlico'
    else
    if f ='EDAJF08' then textoAjuda := '  S - incio de sublinhado'
    else
    if f ='EDAJF09' then textoAjuda := '  CONTROL + S - fim de sublinhado'
    else

    if f ='EDAJMF1' then textoAjuda := '  F - fonte'
    else
    if f ='EDAJMF2' then textoAjuda := '  A - alinhamento'
    else

    if f ='EDAJMM1' then textoAjuda := 'Os comandos de maisculas e minusculas so:'
    else
    if f ='EDAJMM2' then textoAjuda := '  A - maiscula'
    else
    if f ='EDAJMM3' then textoAjuda := '  I - minscula'
    else
    if f ='EDAJMM4' then textoAjuda := '  P - Primeira letra maiscula'
    else
    if f ='EDAJMM5' then textoAjuda := '  U - converter para UTF-8'
    else
    if f ='EDAJMM6' then textoAjuda := '  C - contar palavras'
    else

    if f ='EDAUTOMA' then textoAjuda := 'Automtica'
    else
    if f ='EDPRETO' then textoAjuda := 'Preto'
    else
    if f ='EDAZUL' then textoAjuda := 'Azul'
    else
    if f ='EDTURQUE' then textoAjuda := 'Turquesa'
    else
    if f ='EDVERCLA' then textoAjuda := 'Verde claro'
    else
    if f ='EDROSA' then textoAjuda := 'Rosa'
    else
    if f ='EDVERMEL' then textoAjuda := 'Vermelho'
    else
    if f ='EDAMAREL' then textoAjuda := 'Amarelo'
    else
    if f ='EDBRANCO' then textoAjuda := 'Branco'
    else
    if f ='EDAZUESC' then textoAjuda := 'Azul escuro'
    else
    if f ='EDCERCET' then textoAjuda := 'Cerceta'
    else
    if f ='EDVERDE' then textoAjuda := 'Verde'
    else
    if f ='EDVIOLET' then textoAjuda := 'Violeta'
    else
    if f ='EDVERESC' then textoAjuda := 'Vermelho escuro'
    else
    if f ='EDAMAESC' then textoAjuda := 'Amarelo escuro'
    else
    if f ='EDCINZ50' then textoAjuda := 'Cinza 50'
    else
    if f ='EDCINZ25' then textoAjuda := 'Cinza 25'
    else

    if f = 'EDAJFF1' then textoAjuda := 'Os modos de falar a formatao so:'
    else
    if f = 'EDAJFF2' then textoAjuda := '  N - natural'
    else
    if f = 'EDAJFF3' then textoAjuda := '  F - formatao'
    else
    if f = 'EDAJFF4' then textoAjuda := '  B - bips'
    else
    if f = 'EDAJFF5' then textoAjuda := '  M - mudo'
    else

;
//neno textoajuda
end;

function txtmsg (f: string): string;
begin
    if f = 'EDCFVEL'  then txtmsg := 'Use as setas para selecionar.'
    else
    if f = 'EDVELC'   then txtmsg := 'Velocidade: '
    else
    if f = 'EDINSLIN' then txtmsg := 'ENTER insere linha: '
    else
    if f = 'EDQUEAUT' then txtmsg := 'Quebrar linhas: '
    else
    if f = 'EDFALPON' then txtmsg := 'Falar pontuao: '
    else
    if f = 'EDFALAUT' then txtmsg := 'Fala automtica: '
    else
    if f = 'EDCOMDIC' then txtmsg := 'Com dicionrio: '
    else
    if f = 'EDMODFOR' then txtmsg := 'Modo formatao (N, F, B ou M): '
    else
    if f = 'EDCOMSAP' then txtmsg := 'Com SAPI: '
    else
    if f = 'EDNUMSAP' then txtmsg := 'Nmero SAPI: '
    else
    if f = 'EDVEL'    then txtmsg := 'Velocidade SAPI: '
    else
    if f = 'EDTOM'    then txtmsg := 'Tonalidade SAPI: '
    else
    if f = 'EDTIPSAP' then txtmsg := 'Tipo SAPI (3, 4 ou 5): '
    else
    if f = 'EDTIPSPX' then txtmsg := 'Tipo SAPI (3, 4, 5 ou 54): '
    else
    ;
end;

{--------------------------------------------------------}

Procedure Fala (f: String);
begin
    gotoxy (1, 9);
    textBackground (BLUE);
    falaSeguinte (f);
end;

{--------------------------------------------------------}

Procedure FalaSeguinte (f: String);
var arq: file;
    s: string;
begin
    s := '----- erro de mensagem ???? ----';

    if f = 'EDMSGINI' then s := 'EDIVOX - v.' + versao+^m+^j+
                                'Autor: Marcelo Pimentel'
    else
    if f = 'EDSEMTRD' then s := 'Erro no diretorio do tradutor'
    else
    if f = 'EDQUERSV' then s := 'Quer salvar o arquivo (s/n) ? '
    else
    if f = 'EDFIMPRC' then s := 'Fim do EDIVOX - Autor: Marcelo Pimentel'
    else
    if f = 'EDDIGNOM' then s := 'Qual o nome do Arquivo? '
    else
    if f = 'EDREESCR' then s := 'Arquivo j existe, reescreve (s/n) ?'
    else
    if f = 'EDARQGRV' then s := 'Arquivo gravado'
    else
    if f = 'EDARTRUN' then s := 'Arquivo enorme foi truncado'
    else
    if f = 'EDARQNOV' then s := 'Arquivo novo'
    else
    if f = 'EDARQCRG' then s := 'Arquivo carregado'
    else
    if f = 'EDQUERSN' then s := 'Quer salvar este texto (s/n)'
    else
    if f = 'EDERRESC' then s := 'Erro de escrita no arquivo'
    else
    if f = 'EDERRLEI' then s := 'Erro de leitura no arquivo'
    else
    if f = 'EDOPRINV' then s := 'Operao invlida'
    else
    if f = 'EDLINHA'  then s := 'Linha: '
    else
    if f = 'EDCOLUNA' then s := 'Coluna: '
    else
    if f = 'EDDEL'    then s := 'DEL'
    else
    if f = 'EDFALDLG' then s := 'Fala desligada'
    else
    if f = 'EDFALACI' then s := 'Fala acionada'
    else
    if f = 'EDLINREM' then s := 'Linha removida'
    else
    if f = 'EDCNFSAI' then s := 'Confirma saida (s/n) ? '
    else
    if f = 'EDDIGMD'  then s := 'Informe a margem direita: '
    else
    if f = 'EDDIGME'  then s := 'Informe a margem esquerda: '
    else
    if f = 'EDMARINV' then s := 'Margem invalida'
    else
    if f = 'EDMARACI' then s := 'Margem acionada'
    else
    if f = 'EDACENT'  then s := 'Acentuacao acionada'
    else
    if f = 'EDNACENT' then s := 'Acentuacao desligada'
    else
    if f = 'EDINITEX' then s := 'Inicio do texto'
    else
    if f = 'EDFIMTEX' then s := 'Fim do texto'
    else
    if f = 'EDBLKMOV' then s := 'Bloco movido'
    else
    if f = 'EDBLKCPY' then s := 'Bloco copiado'
    else
    if f = 'EDBLKCRG' then s := 'Bloco carregado'
    else
    if f = 'EDBLKADC' then s := 'Bloco adicionado'
    else
    if f = 'EDBLKORD' then s := 'Bloco ordenado'
    else
    if f = 'EDBLKCNT' then s := 'Bloco centrado'
    else
    if f = 'EDBLKTAB' then s := 'Bloco tabulado'
    else
    if f = 'EDBLKMRG' then s := 'Bloco margeado'
    else
    if f = 'EDBLKALI' then s := 'Bloco alinhado'
    else
    if f = 'EDBLKPAR' then s := 'Bloco pargrafo'
    else
    if f = 'EDBLKINV' then s := 'Bloco invalido'
    else
    if f = 'EDBLKREM' then s := 'Bloco removido'
    else
    if f = 'EDCMDBLK' then s := 'Comando de bloco: '
    else
    if f = 'EDBLKMAR' then s := 'Bloco marcado'
    else
    if f = 'EDINCOMP' then s := 'Bloco incompleto'
    else
    if f = 'EDINIBLK' then s := 'Inicio do bloco'
    else
    if f = 'EDFIMBLK' then s := 'Fim do bloco'
    else
    if f = 'EDJUSTIF' then s := 'Trecho justificado'
    else
    if f = 'EDPOSINV' then s := 'Posicao de bloco invalida'
    else
    if f = 'EDBLKDSM' then s := 'Bloco desmarcado'
    else
    if f = 'EDLINQUE' then s := 'Linha quebrada'
    else
    if f = 'EDAPAINI' then s := 'Apagado a esquerda'
    else
    if f = 'EDAPAFIM' then s := 'Apagado a direita'
    else
    if f = 'EDLINSER' then s := 'Linha nova'
    else
    if f = 'EDLGRAND' then s := 'Linha excederia 150 letras, nao juntei'
    else
    if f = 'EDLINJUN' then s := 'Linhas juntadas'
    else
    if f = 'EDTXTPRC' then s := 'Qual o texto ? '
    else
    if f = 'EDTXTENC' then s := 'Texto encontrado'
    else
    if f = 'EDTXNENC' then s := 'Texto nao encontrado'
    else
    if f = 'EDTXTTRC' then s := 'Texto trocado'
    else
    if f = 'EDQUATRE' then s := 'Qual o texto nas linhas a excluir?'
    else

    if f = 'EDARQNAO' then s := 'Arquivo nao existe'
    else
    if f = 'EDNOME'   then s := 'Nome deste arquivo: '
    else
    if f = 'EDFORTXT' then s := 'Usa acentuacao internacional (s/n) '
    else

    if f = 'EDLINGRA' then s := 'Linhas grandes foram divididas'
    else
    if f = 'EDNOMGRV' then s := 'Nome do arquivo a gravar: '
    else
    if f = 'EDESCCAN' then s := 'Gravacao de arquivo cancelada'
    else
    if f = 'EDDGNLIN' then s := 'Digite o numero da linha: '
    else
    if f = 'EDLINAO'  then s := 'Linha nao existe'
    else
    if f = 'EDVELOC'  then s := 'Qual a velocidade, de 1 a 5? '
    else
    if f = 'EDCOLMAR' then s := 'Informe a coluna da esquerda: '
    else
    if f = 'EDNCLIND' then s := 'Numero de colunas a indentar: '
    else
    if f = 'EDDESIST' then s := 'Desistiu... '
    else
    if f = 'EDTABINS' then s := 'Tabulacao inserida'
    else
    if f = 'EDTABCAN' then s := 'Tabulacoes canceladas'
    else
    if f = 'EDENTINS' then s := 'Enter vai inserir linha'
    else
    if f = 'EDENTNIN' then s := 'Enter nao vai inserir linha'
    else
    if f = 'EDSOLETR' then s := 'Soletragem acionada'
    else
    if f = 'EDNSOLET' then s := 'Soletragem desligada'
    else
    if f = 'EDMEMPEQ' then s := 'Memoria muito reduzida.  Tecle ENTER.'
    else
    if f = 'EDINFTXT' then s := 'Informe o novo texto: '
    else
    if f = 'EDTODBLK' then s := 'Todo texto (T) ou bloco (B): '
    else
    if f = 'EDCOMAND' then s := 'Qual comando? '
    else
    if f = 'EDOPCAO'  then s := 'Qual opcao? '
    else
    if f = 'EDQAUTO'  then s := 'Quebra automatica ligada'
    else
    if f = 'EDNQAUTO' then s := 'Quebra automatica desligada'

    else
    if f = 'EDNUM'    then s := 'Num Lock ligado'
    else
    if f = 'EDNONUM'  then s := 'Num Lock desligado'
    else
    if f = 'EDCAPS'   then s := 'Caps Lock ligado'
    else
    if f = 'EDNOCAPS' then s := 'Caps Lock desligado'
    else
    if f = 'EDERRSRV' then s := 'Erro no servidor'
    else
    if f = 'EDGRANDE' then s := 'Bloco muito grande'

    else
    if f = 'EDCOPTRU' then s := 'Bloco no pode ser transcrito por tem mais de 65000 letras'
    else
    if f = 'EDBLKTRN' then s := 'Bloco trazido foi truncado por ser muito grande'
    else
    if f = 'EDDICNAO' then s := 'Dicionrio no foi achado'
    else
    if f = 'EDUTF8'   then s := 'Escolha q para quoted-printable, u para utf-8 ou g para yahoogroups'
    else
    if f = 'EDAGUARD' then s := 'Aguarde ...'
    else
    if f = 'EDDESCON' then s := 'Deseja tentar converter o arquivo para TXT? '
    else
    if f = 'EDMAIUSC' then s := 'Deseja converter o bloco para maiscula? '
    else
    if f = 'EDPUTF8' then s := 'Deseja codificar o bloco para UTF-8'
    else
    if f = 'EDDECODI' then s := 'Deseja decodificar o texto?'
    else
    if f = 'EDDICIOA' then s := 'Dicionrio ativado'
    else
    if f = 'EDDICIOD' then s := 'Dicionrio desativado'

    else
    if f = 'EDCONVER' then s := 'Converses. Tecle F1 para ajuda.'
    else
    if f = 'EDINFPOT' then s := 'Qual a potncia?'

    else
    if f = 'EDSEMSUG' then s := 'Sem sugestes'
    else
    if f = 'EDALTERN' then s := 'Use as setas para alternativas'
    else
    if f = 'EDOK'     then s := 'OK'
    else
    if f = 'EDPAICON' then s := 'Painel de configurao'
    else
    if f = 'EDVELC'   then s := 'Velocidade : '
    else
    if f = 'EDINSLIN' then s := 'ENTER insere linha: '
    else
    if f = 'EDQUEAUT' then s := 'Quebra automtica: '
    else
    if f = 'EDFALPON' then s := 'Fala pontuao: '
    else
    if f = 'EDFALAUT' then s := 'Fala automtica: '
    else
    if f = 'EDCOMDIC' then s := 'Com dicionrio: '
    else
    if f = 'EDCOMSAP' then s := 'Com Sapi: '
    else
    if f = 'EDNUMSAP' then s := 'Nmero SAPI: '
    else
    if f = 'EDVEL'    then s := 'Velocidade SAPI: '
    else
    if f = 'EDTOM'    then s := 'Tonalidade SAPI: '
    else
    if f = 'EDDICATI' then s := 'O dicionrio ser ativado'
    else
    if f = 'EDAGUARC' then s := 'Aguarde, configurando'
    else
    if f = 'EDCARDIC' then s := 'Carregando dicionrio'
    else
    if f = 'EDREFORM' then s := 'Junta linhas para exportar? '

    else
    if f = 'EDNEXEC' then s := 'No pude executar'
    else
    if f = 'EDCFVEL'  then s := 'Use as setas para selecionar.'
    else
    if f = 'EDINFVAL' then s := 'Informe o valor '
    else
    if f = 'EDFONTES' then s := 'Fontes'
    else
    if f = 'EDDE' then s := ' de '
    else
    if f = 'EDLIDO' then s := ' lido '
    else
    if f = 'EDTXTNEX' then s := 'Falta o arquivo txtword.exe'
    else
    if f = 'EDDIGTAM' then s := 'Digite o tamanho da fonte'
    else
    if f = 'EDOPCINV' then s := 'Opo invlida'
    else
    if f = 'EDINSFOR' then s := 'Inserir marcas de formatao'

    else
    if f ='EDAUTOMA' then s := 'Automtica'
    else
    if f ='EDPRETO' then s := 'Preto'
    else
    if f ='EDAZUL' then s := 'Azul'
    else
    if f ='EDTURQUE' then s := 'Turquesa'
    else
    if f ='EDVERCLA' then s := 'Verde claro'
    else
    if f ='EDROSA' then s := 'Rosa'
    else
    if f ='EDVERMEL' then s := 'Vermelho'
    else
    if f ='EDAMAREL' then s := 'Amarelo'
    else
    if f ='EDBRANCO' then s := 'Branco'
    else
    if f ='EDAZUESC' then s := 'Azul escuro'
    else
    if f ='EDCERCET' then s := 'Cerceta'
    else
    if f ='EDVERDE' then s := 'Verde'
    else
    if f ='EDVIOLET' then s := 'Violeta'
    else
    if f ='EDVERESC' then s := 'Vermelho escuro'
    else
    if f ='EDAMAESC' then s := 'Amarelo escuro'
    else
    if f ='EDCINZ50' then s := 'Cinza 50'
    else
    if f ='EDCINZ25' then s := 'Cinza 25'

    else
    if f = 'EDFONTE' then s := 'Fonte'
    else
    if f = 'EDTAMANH' then s := 'Tamanho'
    else
    if f = 'EDALIJUS' then s := 'Alinhamento justificado'
    else
    if f = 'EDALICEN' then s := 'Alinhamento centralizado'
    else
    if f = 'EDALIESQ' then s := 'Alinhamento  esquerda'
    else
    if f = 'EDALIDIR' then s := 'Alinhamento  direita'
    else
    if f = 'EDININEG' then s := 'Incio de negrito'
    else
    if f = 'EDFIMNEG' then s := 'Fim de negrito'
    else
    if f = 'EDINIITA' then s := 'Incio de itlico'
    else
    if f = 'EDFIMITA' then s := 'Fim de itlico'
    else
    if f = 'EDINISUB' then s :=  'Incio de sublinhado'
    else
    if f = 'EDFIMSUB' then s :=  'Fim de sublinhado'
    else
    if f = 'EDNEGRIT' then s := 'Negrito'
    else
    if f = 'EDITALIC' then s := 'Itlico'
    else
    if f = 'EDSUBLIN' then s := 'Sublinhado'
    else
    if f = 'EDMINUSC' then s := 'Deseja converter o bloco para minscula?'
    else
    if f = 'EDPRIMAI' then s := 'Deseja converter primeira letra de todo bloco para maiscula?'
    else
    if f = 'EDPALAVR' then s := 'palavras'
    else
    if f = 'EDSOMLEI' then s := 'Este arquivo  somente leitura, provavelmente no ser gravado'
    else
    if f = 'EDFOROCU' then s := 'Formatao oculta na tela'
    else
    if f = 'EDFORAPA' then s := 'Formatao aparente na tela'
    else
    if f = 'EDMOFAFO' then s := 'Modos de falar formatao'
    else
    if f = 'EDORIUTF' then s := 'Original contm texto em UTF-8 na linha '
    else
    if f = 'EDRETOMA' then s := 'Retomando na linha '
    else
    if f = 'EDRECUST' then s := 'Edies recentes, use as setas.'
    else
    if f = 'EDPDFNEX' then s := 'Falta instalar o conversor de PDF para TXT, pdftotext'

//neno
    else
    ;

    write (s);
    textBackground (BLACK);
    clreol;

(*
    assign (arq, dirSomEdivox + '\' + f + '.WAV');
    {$I-}  reset (arq);  {$I+}
    if ioresult <> 0 then
         sintetiza (s)
    else
        begin
            close (arq);
            sintSom (f);
        end;
*)
    if existeArqSom ('EF_' + f) then
        sintSom ('EF_' + f);

    if existeArqSom (f) then
        sintSom (f)
    else
        sintetiza (s);
end;

{--------------------------------------------------------}

function leTeclaMaiusc: char;
var tecla : char;
begin
    tecla := sintReadKey;
    leTeclaMaiusc := upcase (tecla);
end;

end.
